//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
  vector<int> coll;

  INSERT_ELEMENTS(coll,1,3);
  PRINT_ELEMENTS(coll," :\n");

  //      ,  
  //     
  //   -      ,
  //   -     
  //   -    
  cout << ToRus(":\n");
  while (next_permutation(coll.begin(),coll.end())) {
      PRINT_ELEMENTS(coll," ");
  }
  PRINT_ELEMENTS(coll," :\n");

  //      ,
  //         
  //   -      
  //   -  ,     
  while (prev_permutation(coll.begin(),coll.end())) {
      PRINT_ELEMENTS(coll," ");
  }
  PRINT_ELEMENTS(coll," :\n");

  //      ,
  //         
  //   -      ,
  //   -     
  //   -    
  while (prev_permutation(coll.begin(),coll.end())) {
      PRINT_ELEMENTS(coll," ");
  }
    PRINT_ELEMENTS(coll,":\n");


  getch();
  return 0;
}

//---------------------------------------------------------------------------